require 'basecomm_sdk/version'
require 'midwire_common/hash'
require 'faraday'
require 'json'

# Create a .test.env and a .development.env for your different local
# environments
require 'dotenv'
paths = %W(.env .local.env .env.#{ENV['STAGE']}).map do |name|
  Dir.pwd + '/' + name
end
Dotenv.load(*paths).each { |k, v| ENV[k] = v }

module BasecommSdk
  def self.root
    Pathname.new(File.dirname(__FILE__)).parent
  end

  def logger
    @logger ||= Logger.new($stdout).tap { |l| l.level = Logger::DEBUG }
  end

  autoload :Address,                'basecomm_sdk/address'
  autoload :BankAccount,            'basecomm_sdk/bank_account'
  autoload :BankAccountTransaction, 'basecomm_sdk/bank_account_transaction'
  autoload :BankCard,               'basecomm_sdk/bank_card'
  autoload :BankCardTransaction,    'basecomm_sdk/bank_card_transaction'
  autoload :Base,                   'basecomm_sdk/base'
  autoload :Client,                 'basecomm_sdk/client'
  autoload :PushNotification,       'basecomm_sdk/push_notification'
  autoload :SettlementBatch,        'basecomm_sdk/settlement_batch'
  autoload :TripleDesService,       'basecomm_sdk/triple_des_service'
end
