module BasecommSdk
  class Address < Base
    NAME = {
      xs_address_name_home:     'HOME',
      xs_address_name_work:     'WORK',
      xs_address_name_mailing:  'MAILING',
      xs_address_name_shipping: 'SHIPPING',
      xs_address_name_billing:  'BILLING',
      xs_address_name_dba:      'DBA',
      xs_address_name_legal:    'LEGAL'
    }

    attr_accessor :name, :line1, :line2, :line3, :city, :state, :zipcode,
      :country

    def self.build_from_json(json)
      Address.new(JSON.parse(json).recursively_symbolize_keys!)
    end
    singleton_class.send(:alias_method, :from_json, :build_from_json)

    def json_prefix
      :address
    end
  end
end
