module BasecommSdk
  class BankAccount < Base
    TYPE = {
      xs_ba_type_checking: 'CHECKING',
      xs_ba_type_savings:  'SAVINGS'
    }
    ENTITY = {
      xs_ba_entity_individual:   'INDIVIDUAL',
      xs_ba_entity_organization: 'ORGANIZATION'
    }
    STATUS = {
      xs_ba_status_active:  'ACTIVE',
      xs_ba_status_deleted: 'DELETED',
      xs_ba_status_failed:  'FAILED'
    }

    attr_accessor :name, :alias, :account_number, :routing_number, :token,
      :status, :type

    def self.build_from_json(json)
      BankAccount.new(JSON.parse(json).recursively_symbolize_keys!)
    end
    singleton_class.send(:alias_method, :from_json, :build_from_json)

    def json_prefix
      :bank_account
    end
  end
end
