module BasecommSdk
  class BankCard < Base
    STATUS = {
      xs_bc_status_active:  'ACTIVE',
      xs_bc_status_deleted: 'DELETED',
      xs_bc_status_failed:  'FAILED'
    }

    attr_accessor :name, :number, :alias, :expiration_month, :expiration_year,
      :status, :billing_address, :token, :creation_date, :last_used_date

    def self.build_from_json(json)
      BankCard.new(JSON.parse(json).recursively_symbolize_keys!)
    end
    singleton_class.send(:alias_method, :from_json, :build_from_json)

    def initialize(options = {})
      super
      @billing_address = Address.new
    end

    def json_prefix
      :bank_card
    end
  end
end
