module BasecommSdk
  class BankCardTransaction < Base
    TYPE = {
      xs_bct_type_auth:     'AUTH',
      xs_bct_type_sale:     'SALE',
      xs_bct_type_void:     'VOID',
      xs_bct_type_capture:  'CAPTURE',
      xs_bct_type_refund:   'REFUND',
      xs_bct_type_credit:   'CREDIT'
    }

    STATUS = {
      xs_bct_status_created: 'CREATED',
      xs_bct_status_authorized: 'AUTHORIZED',
      xs_bct_status_captured: 'CAPTURED',
      xs_bct_status_settled: 'SETTLED',
      xs_bct_status_voided: 'VOIDED',
      xs_bct_status_declined: 'DECLINED',
      xs_bct_status_failed: 'FAILED',
      xs_bct_status_3dsecure: '3DSECURE',
      xs_bct_status_verified: 'VERIFIED'
    }

    attr_accessor :billing_address, :type, :card_number, :card_name,
      :expiration_month, :expiration_year, :card_cvv2,
      :card_track1_data, :card_track2_data, :ip_address, :po_number,
      :authorization_code,
      :response_code, :status, :response_message, :cvv_response_code,
      :avs_response_code, :encrypted_track_data, :merchant_transaction_id,
      :verify_complete_url, :verify_url, :amount, :tax_amount, :tip_amount,
      :id, :settlement_batch_id, :check_secure_code, :recurring_indicator,
      :token, :settlement_date, :creation_date

    attr_accessor :custom_field1, :custom_field2, :custom_field3,
      :custom_field4, :custom_field5, :custom_field6, :custom_field7,
      :custom_field8, :custom_field9, :custom_field10

    def self.build_from_json(json)
      BankCardTransaction.new(JSON.parse(json).recursively_symbolize_keys!)
    end
    singleton_class.send(:alias_method, :from_json, :build_from_json)

    def initialize(options = {})
      super
      @billing_address = Address.new
    end

    def json_prefix
      :bank_card_transaction
    end
  end
end
