require 'openssl'

module BasecommSdk
  class TripleDesService
    attr_reader :key

    def initialize(key)
      @key = key
    end

    def encrypt(input)
      cipher.encrypt
      cipher_result = ''
      cipher_result << cipher.update(input)
      cipher_result << cipher.final
      cipher_result.unpack('H*')[0]
    end

    def decrypt(input)
      cipher.decrypt
      cipher_result = ''
      cipher_result << cipher.update([input].pack('H*'))
      cipher_result << cipher.final
      cipher_result
    end

    private

    def cipher
      @cipher ||= OpenSSL::Cipher::Cipher.new('des-ede3').tap do |c|
        c.padding = 1
        c.key = [key].pack('H*')
      end
    end
  end
end
